<?php

/**
 * Classe spxnewsletterInstall rassemblant les fonctions utiles pour installer les donnees de spxnewletter
 *
 * @package SPX
 * @author	JEVRARD
 **/
class spxnewsletterInstall {
	
	protected static $plxMotor;
	protected static $rootme;
	protected static $rootPlugins;
	protected static $aPackage;
	
	protected static $slog;
	
	
	public static function init() {
		if(!is_dir(PLX_PLUGINS.'/cache')) {
			mkdir(PLX_PLUGINS.'/cache',0755,true);
		}
		
		self::$plxMotor = plxMotor::getInstance();
		
		self::$rootme= PLX_PLUGINS.'spxwnewsletter/';
		self::$rootPlugins= PLX_PLUGINS;
		
		
		self::$aPackage["pluginsneeded"] = array();
		
		# add plugin list
		$tmp  = array("zipname" => "spxdatas.1.71", "name" => "spxdatas", "version" => "1.71");
		self::$aPackage["pluginsneeded"][$tmp["name"]]=$tmp;
		
	}
	
	public static function getpluginneeded() {
		return self::$aPackage["pluginsneeded"];
	}
	
	public static function dopackage($content) {
		self::set_file_spxdatas();
	}
	
	# check if a plugin exist
	public static function plugin_check_exist($plugname) {
		if(!is_file(PLX_PLUGINS.$plugname.'/infos.xml'))
				return false;
			else
				return true;
	}

	# check if a plugin is desactived
	public static function plugin_check_inactive($plugname) {
		$tmp = self::$plxMotor->plxPlugins->getInactivePlugins();
		$tmp2 = $tmp[$plugname];
		if ($tmp2){
			return true;
		}else{
			return false;
		}
	}
	
	# check if a plugin is actived
	public static function plugin_check_active($plugname) {
		$tmp = self::$plxMotor->plxPlugins->aPlugins[$plugname];
		if ($tmp){
			return true;
		}else{
			return false;
		}
	}
	
	# active plugin
	public static function plugin_active($name) {
		//$plxAdmin->plxPlugins->saveConfig($_POST);
		$content['selection']='activate';
		$content['chkAction'][0]=$name;
		$content ['plugName'][0]=$name;
		self::$plxMotor->plxPlugins->saveConfig($content);
	}
	
	# desactive plugin
	public static function plugin_deactivate($name) {
		$content['selection']='deactivate';
		$content['chkAction'][0]=$name;
		$content ['plugName'][0]=$name;
		self::$plxMotor->plxPlugins->saveConfig($content);
	}
	
	# install plugin configuration (if not exist)
	public static function plugin_update_config($plugName) {
		$file = self::$rootme."package/plugins/".basename($plugName).'.xml';
		if (file_exists($file)) {
			$file_frontend = PLX_ROOT.PLX_CONFIG_PATH.'plugins/'.basename($plugName).'.xml';
			if (!file_exists($file_frontend)) {		
				spxwnewsletterUtils::copyFile($file,$file_frontend);
			}
		}
	}
	
	# get a param for a plugin
	public static function plugin_getParam($plugName,$param) {
		$plug = self::$plxMotor->plxPlugins->aPlugins[$plugName];
		return $plug->getParam($param);
	}
	
	# get an info for a plugin :: return info $s = spxthemesimpleInstall::plugin_getInfos("spxdatas", "version");
	public static function pluginactif_getInfos($name,$info='version') {
		$plug = self::$plxMotor->plxPlugins->aPlugins[$name];
		return $plug->getInfo($info);
	}
	# get an info for inactif plugin
	public static function plugininactif_getInfos($name,$info='version') {
		$tmp = self::$plxMotor->plxPlugins->getInactivePlugins();
		$plug = $tmp[$name];
		return $plug->getInfo($info);
	}
	
	# only available if spxdata is actived
	public static function getPathData_spxdatas() {
		$plxMotor = plxMotor::getInstance();
		return $plxMotor->plxPlugins->aPlugins["spxdatas"]->getPathData();
	}
	
	# check data situation return false or true depending of data needed (just for reading)
	public static function get_data_situation() {
		# check folder data
		$rootfolderdata = self::getPathData_spxdatas();
		# check all xml needed one by one
		$xmldatafolder = self::$rootme.'package/spxdatas/data/';
		self::set_log ("xmldatafolder", $xmldatafolder);
		$tmp = spxnewsletterUtils::dirToArray($xmldatafolder);
		foreach($tmp as $key=>$val) { 
			$xml = $rootfolderdata.$val;
			self::set_log ("xml", $xml);
			if (!file_exists($xml)) return false;
		}
		return true;
	}
	
	# copy data in spxdata data
	public static function set_file_spxdatas() {
		$rootfolderdata = self::getPathData_spxdatas();
		self::set_log ("spxdatas rootfile", $rootfolderdata);
		
		# data xml
		if(!is_dir($rootfolderdata)) spxwnewsletterUtils::newDir($rootfolderdata."/");
		
		# check all xml needed one by one
		$xmldatafolder = self::$rootme.'package/spxdatas/data/';
		$tmp = spxnewsletterUtils::dirToArray($xmldatafolder);
		foreach($tmp as $key=>$val) { 
			$xml = $rootfolderdata.$val;
			self::set_log ("xml", $xml);
			if (!file_exists($xml)) {
				self::set_log ("copy xml");
				// copy xml
				$origin = self::$rootme.'package/spxdatas/data/'.$val;
				spxnewsletterUtils::copyFile($origin,$xml);
			}else{
				self::set_log ("file xml exist");
				
			}
		}
		
	}
	
	public static function set_log($title,$s="") {
		self::$slog.=$title." : ".$s."\n<br>";
	}
	public static function get_log() {
		return "<strong>logs:</strong>\n<br>\n<br>".self::$slog;
	}
	
}





?>